//===----------------------------------------------------------------------===//
//
// Philipp Schubert
//
//    Copyright (c) 2017 - 2021
//    Secure Software Engineering Group
//    Heinz Nixdorf Institute
//    Paderborn University
//    philipp.schubert@upb.de
//
//===----------------------------------------------------------------------===//

#include <chrono>
#include <functional>
#include <future>
#include <iostream>
#include <thread>

unsigned factorial(std::future<unsigned> f) {
  unsigned result = 1;
  unsigned n = f.get();
  for (unsigned i = n; i > 0; --i) {
    result *= i;
  }
  return result;
}

int main() {
  std::promise<unsigned> p;
  std::future<unsigned> f = p.get_future();
  std::future<unsigned> fu =
      std::async(std::launch::async, factorial, std::move(f));
  std::this_thread::sleep_for(std::chrono::seconds(10));
  p.set_value(4);
  unsigned result = fu.get();
  std::cout << result << '\n';
  return 0;
}
